
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Interactive Globe</title>
     
  <style> 
    body { 
        margin: 0; 
        display: inline-block;
        justify-content: center; /* Center the container horizontally */
        height: 50vh; 
    }
    #container {
        display: inline-block;
        width: 30vw; /* Reduce width to allow for 5% padding on each side */
        height: 50vh;
        padding: 0 5vw; /* 5% padding on each side */
    }
    #controls {
        flex-grow: 1; /* Takes 1 part of the flex space (approximately 33%) */
        padding: 10px;
        overflow-y: visible;
    }
    #globeViz {
        flex-grow: 2; /* Takes 2 parts of the flex space (approximately 67%) */
        width: 30vw; /* Reduce width to allow for 5% padding on each side */
        height: 1vh;
        padding: 0 30vw; /* 5% padding on each side */
    }
  
    .slider {
        width: 100%;
    }
</style>

    <!-- globe.gl: This is the main library for creating the interactive 3D globe. It uses three.js under the hood for WebGL rendering. -->
    <script src="https://unpkg.com/globe.gl"></script>
    <!-- topojson-client: This library is used to convert TopoJSON data into a more widely-used format (like GeoJSON) that can be rendered by globe.gl. -->
    <script src="https://unpkg.com/topojson-client@3"></script>
</head>



<body>
    <div id="container">
        <div id="globeViz"></div>
        <div id="controls">
            Color: <input type="color" id="color-picker" value="#ff0000"><br>
            
            Height: <input type="range" id="height-slider" class="slider" min="0.01" max="1.0" step="0.01" value="0.5">
            <span id="height-display" class="value-display">0.5</span><br>
            
            Width: <input type="range" id="width-slider" class="slider" min="0.1" max="2.0" step="0.1" value="0.5">
            <span id="width-display" class="value-display">0.5</span><br>
                  
            Opacity: <input type="range" id="opacity-slider" class="slider" min="0" max="1" step="0.01" value="1">
            <span id="opacity-display" class="value-display">1.00</span><br>
        </div>
    </div>

   <!-- ES Module script for importing Three.js and globe.gl -->
   <script type="module">
    import * as THREE from 'https://unpkg.com/three/build/three.module.js';
    // Since globe.gl might not have a default export, we don't use import statement for it
    // The Globe function should be available in the global scope after adding the script tag in the head

    // Initialize the globe visualization and set its properties
    const world = Globe()(document.getElementById('globeViz'))
        .backgroundColor('rgba(255, 255, 255, 1)')
        .showGlobe(true)
        .showAtmosphere(false);

    // Fetch and process geographic data for the globe
    fetch('https://raw.githubusercontent.com/johan/world.geo.json/master/countries.geo.json')
    .then(res => res.json())
    .then(countries => {
        world.polygonsData(countries.features)
            .polygonCapMaterial(new THREE.MeshLambertMaterial({ color: 'rgba(139, 149, 246, 1)', side: THREE.DoubleSide }))
            .polygonSideColor(() => 'rgba(255, 255, 255, 1)');

            // Set globe material properties
            const globeMaterial = world.globeMaterial();
            globeMaterial.specular = new THREE.Color('grey');
            globeMaterial.color.set(0xA2A9F8); // Light blue color
            globeMaterial.flatshading = false;

            // Optional: Auto-rotation settings
            world.controls().autoRotate = false;
            world.controls().autoRotateSpeed = 0.6;
        });

        // Generate initial spikes data
        let spikesData = [...Array(3).keys()].map(() => ({
            lat: (Math.random() - 0.5) * 180,
            lng: (Math.random() - 0.5) * 360,
            altitude: 0.1,
            color: 'rgba(255, 0, 0, 1)',
            radius: 0.25
        }));

        // Set spikes data to the globe
        world.pointsData(spikesData)
            .pointAltitude(d => d.altitude)
            .pointColor(d => d.color)
            .pointRadius(d => d.radius);

        // Function to update globe with current spikes data
        function updateGlobe() {
            world.pointsData(spikesData);
        }

        // Event listeners for sliders to control spikes attributes
        
        document.getElementById('height-slider').addEventListener('input', function(e) {
            spikesData.forEach(spike => spike.altitude = parseFloat(e.target.value));
            updateGlobe();
            // Update the display value
        document.getElementById('height-display').textContent = e.target.value;
        });

        document.getElementById('width-slider').addEventListener('input', function(e) {
            spikesData.forEach(spike => spike.radius = parseFloat(e.target.value));
            updateGlobe();
            // Update the display value
        document.getElementById('width-display').textContent = e.target.value;
        });

        document.getElementById('color-picker').addEventListener('input', function(e) {
            const colorValue = e.target.value;
            const opacity = document.getElementById('opacity-slider').value;
            spikesData.forEach(spike => spike.color = `rgba(${hexToRgb(colorValue)}, ${opacity})`);
            updateGlobe();
        });

        document.getElementById('opacity-slider').addEventListener('input', function(e) {
            const opacity = e.target.value;
            const colorValue = document.getElementById('color-picker').value;
            spikesData.forEach(spike => spike.color = `rgba(${hexToRgb(colorValue)}, ${opacity})`);
            updateGlobe();
             // Update the Opacity display value
        document.getElementById('opacity-display').textContent = e.target.value;
        });

        // Convert hex color to RGB string
        function hexToRgb(hex) {
            const result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? `${parseInt(result[1], 16)}, ${parseInt(result[2], 16)}, ${parseInt(result[3], 16)}` : null;
        }
    </script>
</body>
</html>
